#define UNICODE
#define _UNICODE
#undef _MBCS

#define APP_NAME L"ShiftSSA v0.1"
#define MY_URL   L"http://www.faireal.net/"
#define LINE_BUFFER_SIZE 1024 * 10

typedef struct {
	WCHAR lpwcFileName[ MAX_PATH + 1 ];
	WCHAR lpwcFilePath[ MAX_PATH + 1 ];
	WCHAR lpwcCharset[ 256 ];
	WCHAR lpwcVersion[ 256 ];
	DWORD dwDialogues;
	WCHAR lpwcSampleDialogue[ LINE_BUFFER_SIZE ];
} SSAINFO, * LPSSAINFO;

typedef struct{
	WCHAR lpwcHeader[ 128 ];
	double dStart;
	double dEnd;
	WCHAR lpwcRemains[ LINE_BUFFER_SIZE ];
} SSALINEW, * LPSSALINEW;



BOOL GetInputFileName( HWND hWnd, LPSSAINFO lpssa );

int DetectUTF16( LPCTSTR lpszFileName );

#define BOM_ERROR          'e'
#define BOM_NOT_DETECTED   '0'
#define NOT_UTF16          '0'
#define UTF16_LE_BOM       'L'
#define UTF16_LE_NO_BOM    'l'
#define UTF16_BE_BOM       'B'
#define UTF16_BE_NO_BOM    'b'

BOOL PutLineCP( LPCWSTR wcstr, FILE * fout, UINT uCP );


int ReadSSALineW( LPCWSTR lpwcLine, LPSSALINEW lpSSALineW );
#define SSA_LINE_ERROR    -1
#define SSA_LINE_SKIPPED   0
#define SSA_LINE_DIALOGUE  1
#define SSA_LINE_VERSION  10
#define SSA_LINE_EMBEDDED 99

typedef struct {
	WCHAR list[ 10 ][ LINE_BUFFER_SIZE ];
} SSALIST, * LPSSALIST;

int SplitW( LPWSTR lpwcLine, LPSSALIST ls );
BOOL PathToFileName( LPCWSTR lpwcPath, LPWSTR lpwcFileName, int iBufferSize );
BOOL PathToDirName( LPCWSTR _lpwcPath, LPWSTR lpwcDirName, int iBufferSize );
BOOL GetBakFileName( LPCWSTR _lpwcPath, LPWSTR lpwcBakPath, int iBufferSize );
BOOL GetBakFileName2( LPCWSTR _lpwcPath, LPWSTR lpwcBakPath, int iBufferSize );

BOOL GetCPString( UINT uCP, LPWSTR str );

BOOL ShowSSAInfo( HWND hDlg, LPSSAINFO s );

BOOL GetSSAInfo( LPCWSTR lpwcPath, LPCWSTR lpwcFileTitle, LPSSAINFO lpssa );
BOOL GetSSAInfo( LPCWSTR lpwcPath, LPSSAINFO lpssa );


BOOL GetSSAVersionFromHeader( LPCWSTR lpwcLine, LPSSAINFO lpssa );
BOOL GetSSAVersionFromDialogue( LPCWSTR lpwcLine, LPSSAINFO lpssa );
VOID ChompW( LPWSTR str );
BOOL GetSSASampleDialogue( LPWSTR lpwcLine, LPSSAINFO lpssa );

BOOL DoShift( HWND hDlg, LPSSAINFO s );

BOOL ShiftSSA( HWND hWnd, LPCWSTR lpwcFilePath, const LONG lShift, const double dFps,
			  const LONG lFrame, const BOOL bLimitGte );

double TimeStringToDoubleW( LPCWSTR lpwcString );
BOOL IsDigitW( WCHAR wc );

double NormalizeSSA( double dSeconds, double dFps );
BOOL NormalizeSSAW( double dSeconds, double dFPS, LPTSTR lpwcString, DWORD dwBufferSize );

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam );

LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK SelectCP( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
#define TEXT_GPL L"This program is free software; you can redistribute it and/or\
 modify it under the terms of the GNU General Public License\
 as published by the Free Software Foundation; either version 2\
 of the License, or (at your option) any later version.\r\n\
\r\n\
This program is distributed in the hope that it will be useful,\
 but WITHOUT ANY WARRANTY; without even the implied warranty of\
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\
 GNU General Public License for more details.\r\n\
\r\n\
You should have received a copy of the GNU General Public License\
along with this program; if not, write to the Free Software\
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.\r\n"