#undef _MBCS
#define UNICODE
#define _UNICODE
#include <stdio.h>
#include <windows.h>
#include <tchar.h>

#include "ShiftSSA.h"
#include "resource.h"
/*
874 	ANSI/OEM - Thai (same as 28605, ISO 8859-15)
932 	ANSI/OEM - Japanese, Shift-JIS
936 	ANSI/OEM - Simplified Chinese (PRC, Singapore)
949 	ANSI/OEM - Korean (Unified Hangeul Code)
950 	ANSI/OEM - Traditional Chinese (Taiwan; Hong Kong SAR, PRC)
1250 	ANSI - Central European
1251 	ANSI - Cyrillic
1252 	ANSI - Latin I
1253 	ANSI - Greek
1254 	ANSI - Turkish
1255 	ANSI - Hebrew
1256 	ANSI - Arabic
1257 	ANSI - Baltic
1258 	ANSI/OEM - Vietnamese
*/
extern HFONT hFontArial;

BOOL GetCPString( UINT uCP, LPWSTR str )
{
	if( uCP == 874 ) wcscpy( str, L"ANSI/OEM - Thai (same as 28605, ISO 8859-15)" );
	else if( uCP == 932 ) wcscpy( str, L"ANSI/OEM - Japanese, Shift-JIS" );
	else if( uCP == 936 ) wcscpy( str, L"ANSI/OEM - Simplified Chinese (PRC, Singapore)" );
	else if( uCP == 949 ) wcscpy( str, L"ANSI/OEM - Korean (Unified Hangeul Code)" );
	else if( uCP == 950 ) wcscpy( str, L"ANSI/OEM - Traditional Chinese (Taiwan; Hong Kong SAR, PRC)" );
	else if( uCP == 1250 ) wcscpy( str, L"ANSI - Central European" );
	else if( uCP == 1251 ) wcscpy( str, L"ANSI - Cyrillic" );
	else if( uCP == 1252 ) wcscpy( str, L"ANSI - Latin I" );
	else if( uCP == 1253 ) wcscpy( str, L"ANSI - Greek" );
	else if( uCP == 1254 ) wcscpy( str, L"ANSI - Turkish" );
	else if( uCP == 1255 ) wcscpy( str, L"ANSI - Hebrew" );
	else if( uCP == 1256 ) wcscpy( str, L"ANSI - Arabic" );
	else if( uCP == 1257 ) wcscpy( str, L"ANSI - Baltic" );
	else if( uCP == 1258 ) wcscpy( str, L"ANSI/OEM - Vietnamese" );
	else if( uCP == 65001 ) wcscpy( str, L"Unicode, UTF-8" );
	else wcscpy( str, L"Unknown" );
	
	return TRUE;
}


LRESULT CALLBACK SelectCP( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam )
{
	static HBRUSH hBrush = NULL;
	static iListIndex = 7; // Latin I
	switch (message)
	{
		case WM_CTLCOLORBTN:
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		{
			if( ! hBrush )
			{
				hBrush = CreateSolidBrush( RGB( 0xff, 0xff, 0xee ) );
			}
			SetBkColor( (HDC) wParam, RGB( 0xff, 0xff, 0xee ) );
			return ( LRESULT ) hBrush;
			break;
		}
		case WM_INITDIALOG:
		{
			if( hFontArial )
			{
				SendDlgItemMessage( hDlg, IDC_STATIC_CP_FILE, WM_SETFONT, ( WPARAM ) hFontArial, 0 );
			}
			SetDlgItemText( hDlg, IDC_STATIC_CP_FILE, ( LPWSTR ) lParam );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"  874 - Thai" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"  932 - Japanese, Shift_JIS" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"  936 - Simplified Chinese" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"  949 - Korean" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"  950 - Traditional Chinese" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1250 - Central European" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1251 - Cyrillic" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1252 - Latin I" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1253 - Greek" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1254 - Turkish" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1255 - Hebrew" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1256 - Arabic" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1257 - Baltic" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L" 1258 - Vietnamese" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_ADDSTRING, 0, (LPARAM) L"65001 - Unicode UTF-8" );
			SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_SETCURSEL, iListIndex, 0 );
			return TRUE;
		}
		case WM_COMMAND:
		if( LOWORD( wParam ) == IDC_LIST_CP && HIWORD( wParam ) == LBN_DBLCLK )
		{
			SendMessage( hDlg, WM_COMMAND, IDOK, 0 );
		}
		if( LOWORD( wParam ) == IDCANCEL )
		{
			if( hBrush )
			{
				DeleteObject( hBrush );
				hBrush = NULL;
			}
			EndDialog( hDlg, 0 );
		}
		else if ( LOWORD( wParam ) == IDOK ) 
		{
			UINT uCP = 0;
			WCHAR str[ 1024 ];
			iListIndex = SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_GETCURSEL, 0, 0 );
			
			if( iListIndex == LB_ERR )
			{
				iListIndex = 0;
			}
			else
			{
				SendDlgItemMessage( hDlg, IDC_LIST_CP, LB_GETTEXT, iListIndex, ( LPARAM ) str );
				uCP = ( UINT ) _wtoi( str );
			}
			
			if( hBrush )
			{
				DeleteObject( hBrush );
				hBrush = NULL;
			}
			EndDialog( hDlg, uCP );
		}
		return TRUE;
	}
    return FALSE;
}


BOOL PutLineCP( LPCWSTR wcstr, FILE * fout, UINT uCP )
{
	if( uCP == 0 )
	{
		return ( fputws( wcstr, fout ) != WEOF );
	}
	char lpMBStr[ LINE_BUFFER_SIZE ] = "";
	if( uCP == 65001 )
	{
		if( ! WideCharToMultiByte( uCP, 0,
						wcstr, -1,
						lpMBStr, LINE_BUFFER_SIZE, NULL, NULL ) ) return FALSE;
	}
	else
	{
		BOOL bUsedDefaultChar = FALSE;
		if( ! WideCharToMultiByte( uCP, 0,
						wcstr, -1,
						lpMBStr, LINE_BUFFER_SIZE, NULL, &bUsedDefaultChar ) ) return FALSE;
		if( bUsedDefaultChar ) return FALSE;
	}

	return ( fputs( lpMBStr, fout ) != EOF );
}