#undef _MBCS
#define UNICODE
#define _UNICODE
#include <stdio.h>
#include <windows.h>
#include <tchar.h>

#include <math.h>

#include "ShiftSSA.h"
#include "resource.h"

extern HINSTANCE hInst;

BOOL GetInputFileName( HWND hWnd, LPSSAINFO lpssa )
{
	OPENFILENAME ofn;
	WCHAR lpwcFileTitle[ MAX_PATH + 1 ] = L"";
	WCHAR lpwcFileName[ MAX_PATH + 1 ] = L"";
	ZeroMemory( &ofn, sizeof( OPENFILENAME ) );
	ofn.lStructSize = sizeof( OPENFILENAME );
	ofn.hwndOwner = hWnd;

	// We put .ssa first before \0, but .ass first after \0
	// Otherwise lpstrDefExt = .ass won't work (Weird...)
	ofn.lpstrFilter = L"SSA, Advanced SSA (*.ssa, *.ass)\0*.ass;*.ssa\0All Files\0*.*\0\0";

	ofn.nFilterIndex = 1;
	ofn.lpstrFile = lpwcFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = lpwcFileTitle;
	ofn.nMaxFileTitle = MAX_PATH;
	ofn.lpstrDefExt = L"ass";
	ofn.Flags = OFN_FILEMUSTEXIST;

	if( !GetOpenFileName( &ofn ) ) return FALSE;

	//SendMessage( hwndEditbox1, WM_SETTEXT, 0, ( LPARAM ) lpwcFileName );
/*
	if( wcslen( lpwcFileName ) < MAX_PATH - 10 )
	{
		wcscpy( str, lpwcFileName );
		int len = wcslen( str );
		str[ len - 4 ] = L'\0';
		wcscat( str, L".shift" );
		wcscat( str, &lpwcFileName[ len - 4 ] );
		wcscat( str, L"\0\0" ); // for sure
		SendMessage( hwndEditbox2, WM_SETTEXT, 0, ( LPARAM ) str );
	}
*/
	if( GetSSAInfo( lpwcFileName, lpwcFileTitle, lpssa ) )
	{
		WCHAR str[ 1024 ];
		wsprintf( str, L"%ls - %ls", lpwcFileTitle, APP_NAME );
		SetWindowText( hWnd, str );
		return TRUE;
	}
	return FALSE;
}

BOOL PathToFileName( LPCWSTR lpwcPath, LPWSTR lpwcFileName, int iBufferSize )
{
	int len = wcslen( lpwcPath );
	for( int i = len - 1; i >= 0 && lpwcPath[ i ] != L'\\'; i-- ){ ; }
	if( lpwcPath[ i ] == L'\\' ) { i++; }
	len = wcslen( &lpwcPath[ i ] );
	if( len >= iBufferSize || len == 0 )
	{
		lpwcFileName[ 0 ] = L'\0';
		return FALSE;
	}
	wcscpy( lpwcFileName, &lpwcPath[ i ] );
	return TRUE;
}

BOOL PathToDirName( LPCWSTR _lpwcPath, LPWSTR lpwcDirName, int iBufferSize )
{
	WCHAR lpwcPath[ MAX_PATH + 1 ];
	int len = wcslen( _lpwcPath );
	if( len > MAX_PATH )
	{
		lpwcDirName[ 0 ] = L'\0';
		return FALSE;
	}
	wcscpy( lpwcPath, _lpwcPath );
	
	for( int i = len - 1; i >= 0 && lpwcPath[ i ] != L'\\'; i-- ){ ; }
	if( lpwcPath[ i ] == L'\\' ) { lpwcPath[ i ] = L'\0'; }
	len = wcslen( lpwcPath );
	if( len >= iBufferSize || len == 0 )
	{
		lpwcDirName[ 0 ] = L'\0';
		return FALSE;
	}
	wcscpy( lpwcDirName, lpwcPath );
	return TRUE;
}

BOOL GetBakFileName( LPCWSTR _lpwcPath, LPWSTR lpwcBakPath, int iBufferSize )
{
	WCHAR lpwcPath[ MAX_PATH * 2 ];
	WCHAR lpwcTest[ 10 ];
	WCHAR lpwcExt[ 10 ];
	int len = wcslen( _lpwcPath );
	if( len > MAX_PATH )
	{
		return GetBakFileName2( _lpwcPath, lpwcBakPath, iBufferSize );
	}
	wcscpy( lpwcPath, _lpwcPath );

	wcscpy( lpwcTest, &lpwcPath[ len - 4 ] );
	CharLowerBuff( lpwcTest, 4 );

	if( wcscmp( lpwcTest, L".ssa" ) == 0 || wcscmp( lpwcTest, L".ass" ) == 0 )
	{
		wcscpy( lpwcExt, lpwcTest );
		lpwcPath[ len - 4 ] = L'\0';
	}
	else
	{
		wcscpy( lpwcExt, L".bak" );
	}
	SYSTEMTIME st;
	GetLocalTime( &st );
	WCHAR str[ 100 ];
	wsprintf( str,
		L"_%4u%02u%02u_%02u%02u%02u",
		st.wYear, st.wMonth, st.wDay,
		st.wHour, st.wMinute, st.wSecond );
	wcscat( lpwcPath, str );
	wcscat( lpwcPath, lpwcExt );
	len = wcslen( lpwcPath );
	if( len <= MAX_PATH && len < iBufferSize )
	{
		wcscpy( lpwcBakPath, lpwcPath );
		return TRUE;
	}
	return GetBakFileName2( _lpwcPath, lpwcBakPath, iBufferSize );
}

BOOL GetBakFileName2( LPCWSTR _lpwcPath, LPWSTR lpwcBakPath, int iBufferSize )
{
	WCHAR lpwcPath[ MAX_PATH ];
	wcsncpy( lpwcPath, _lpwcPath, 3 );
	lpwcPath[ 3 ] = L'\0';
	WCHAR lpwcFileName[ MAX_PATH ];
	PathToFileName( _lpwcPath, lpwcFileName, MAX_PATH );
	SYSTEMTIME st;
	GetLocalTime( &st );
	WCHAR str[ 100 ];
	wsprintf( str,
		L"_%4u%02u%02u_%02u%02u%02u.bak",
		st.wYear, st.wMonth, st.wDay,
		st.wHour, st.wMinute, st.wSecond );
	wcscat( lpwcFileName, str );
	wcscat( lpwcPath, lpwcFileName );
	int len = wcslen( lpwcPath );
	if( len <= MAX_PATH && len < iBufferSize )
	{
		wcscpy( lpwcBakPath, lpwcPath );
		return TRUE;
	}
	wcscpy( lpwcBakPath, L"" );
	return FALSE;
}
