#undef _MBCS
#define UNICODE
#define _UNICODE

#include <windows.h>
#include <tchar.h>

#include "ShiftSSA.h"
#include "resource.h"

HINSTANCE hInst = NULL;
HWND hDlgModeless = NULL;
HWND g_hWnd;
HFONT hFontArial = NULL;

int APIENTRY wWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpszCmdLine, int iCmdShow )
{
	LPCWSTR lpszClassName =  L"ShiftSSA";

	HBRUSH hBrush = CreateSolidBrush( RGB( 0xEE, 0xEE, 0xDD ) );
	hFontArial = CreateFont( 18, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
				CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH,
				L"Arial Unicode MS"	);
	WNDCLASS wc;
	ZeroMemory( &wc, sizeof( WNDCLASS ) );
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = (WNDPROC) WndProc;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE( IDI_ICON2 ) );
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = hBrush;
//	wc.lpszMenuName = ( LPCTSTR ) IDR_MENU1;
	wc.lpszClassName = lpszClassName;

	if( ! RegisterClass ( &wc ) ) return FALSE;

	hInst = hInstance;
	HWND hWnd = CreateWindowEx(
		WS_EX_ACCEPTFILES,
		lpszClassName,
		APP_NAME,
		WS_OVERLAPPED,// | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		800,
		400,
		NULL,
		NULL,
		hInstance,
		NULL
	);

	if( ! hWnd ) 
	{
		DeleteObject( hBrush );
		if( hFontArial ) DeleteObject( hFontArial );
		return FALSE;
	}
	g_hWnd = hWnd;
	//HACCEL hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CCSSA);

	iCmdShow = SW_HIDE;
	ShowWindow( hWnd, iCmdShow );
	MSG msg;
	while( GetMessage( &msg, NULL, 0U, 0U ) )
	{
		if( ! hDlgModeless || ! IsDialogMessage( hDlgModeless, &msg ) )
		{
			//if ( ! TranslateAccelerator( msg.hwnd, hAccelTable, &msg ) ) 
				TranslateMessage( &msg );
				DispatchMessage( &msg );
		}
	}
	if( hFontArial )
	{
		DeleteObject( hFontArial );
	}
	DeleteObject( hBrush );
	return (int) ( msg.wParam );
}


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch ( uMessage )
	{
		case WM_CREATE:
		{
			hDlgModeless = CreateDialog( hInst, (LPCTSTR)IDD_DIALOG1, hWnd, (DLGPROC)DlgProc );
			break;
		}
/*	
		case WM_CHAR:
		{
			WCHAR str[ 1024 ];
			WCHAR tmpstr[ 10 ];
			char c = ( char ) wParam;
			if( c >= '0' && c <= '9' || c=='-' )
			{
				wsprintf( tmpstr, L"%hc", c );
				SendMessage( hwndEBShift, WM_GETTEXT, 100, ( LPARAM ) str );
				int len = wcslen( str );
				if( len <= 8 )
				{
					if( len == 0 || len >= 1 && c != '-' )
					{
						wcscat( str, tmpstr );
						SendMessage( hwndEBShift, WM_SETTEXT, 0, ( LPARAM ) str );
						if( len == 0 ) InvalidateRect( hWnd, NULL, TRUE );
					}
				}
				else
				{
					MessageBox( hWnd,
						L"Use [BackSpace] or [Delete] to clear the editbox.",
						APP_NAME, MB_ICONINFORMATION | MB_OK );
				}
			}
			break;
		}
		
		case WM_KEYDOWN:
		{
			if( wParam == VK_DELETE )
			{
				SendMessage( hwndEBShift, WM_SETTEXT, 0, ( LPARAM ) L"" );
			}
			else if( wParam == VK_BACK )
			{
				WCHAR str[ 1024 ];
				SendMessage( hwndEBShift, WM_GETTEXT, 100, ( LPARAM ) str );
				int len = wcslen( str );
				if( len >= 1 )
				{
					str[ len - 1 ] = L'\0';
					SendMessage( hwndEBShift, WM_SETTEXT, 0, ( LPARAM ) str );
				}
			}
			break;
		}
		
		case WM_COMMAND:
		{
			switch( LOWORD( wParam ) )
			{
				case IDM_OPEN:
					GetInputFileName( hWnd, &ssa );
					SendMessage( hwndEBPath, WM_SETTEXT, 0, ( LPARAM ) ssa.lpwcFilePath );
					InvalidateRect( hWnd, NULL, TRUE );
					break;
				case IDM_SHIFT:
				{
					break;
				}
				case IDM_EXIT:
					SendMessage( hWnd, WM_DESTROY, 0, 0 );
					break;
				case IDM_ABOUT:
					DialogBox( hInst, (LPCTSTR)IDD_DIALOG1, hWnd, (DLGPROC)DlgProc );
//					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
					break;
				default:
					break;
			}
			break;
		}
		case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC	hdc = BeginPaint(hWnd, &ps);
			HFONT hOldFont = (HFONT) SelectObject( hdc, hFontArial );
			SetBkMode( hdc, TRANSPARENT );
			int x = 30, x2 = 160;
			WCHAR str[ LINE_BUFFER_SIZE ];
			SetTextColor( hdc, RGB( 0, 0, 0 ) );
			wcscpy( str, L"File:" );
			TextOut( hdc, x, 30, str, wcslen( str ) );
			SelectObject( hdc, hFontVerdana );
			SetTextColor( hdc, RGB( 0, 0, 0 ) );
			wcscpy( str, L"frame(s) at" );
			TextOut( hdc, 350, 200, str, wcslen( str ) );
			wcscpy( str, L"fps." );
			TextOut( hdc, 580, 200, str, wcslen( str ) );


			if( wcslen( ssa.lpwcFileName ) > 0 )
			{
				SendMessage( hwndEBShift, WM_GETTEXT, 10, ( LPARAM ) str );
				if( wcslen( str ) == 0 )
				{
					SetTextColor( hdc, RGB( 0x66, 0x66, 0x33 ) );
					wcscpy( str, L"Use number keys to input the 'Shift' value." );
					TextOut( hdc, 180, 240, str, wcslen( str ) );
					wcscpy( str, L"A positive/nevative value will increase/decrease the timestamps." );
					TextOut( hdc, 180, 260, str, wcslen( str ) );
				}
				else
				{
					SetTextColor( hdc, RGB( 0x66, 0x66, 0x33 ) );
					wcscpy( str, L"Hit [Enter] to Shift." );
					TextOut( hdc, 180, 240, str, wcslen( str ) );
					wcscpy( str, L"A positive/nevative value will increase/decrease the timestamps." );
					TextOut( hdc, 180, 260, str, wcslen( str ) );
				}
				
				SetTextColor( hdc, RGB( 0, 0, 0xff ) );
				SelectObject( hdc, hFontVerdana );
				wcscpy( str, L"Filename:" );
				TextOut( hdc, x, 80, str, wcslen( str ) );
				SelectObject( hdc, hFontArial );
				wcscpy( str, ssa.lpwcFileName );
				if( wcslen( str ) >= 30 )
				{
					str[ 30 ] = L'\0';
					wcscat( str, L"..." );
				}
				TextOut( hdc, x2, 80, str, wcslen( str ) );
				
				SelectObject( hdc, hFontVerdana );
				SetTextColor( hdc, RGB( 0, 0x80, 0 ) );

				wcscpy( str, L"Format:" );
				TextOut( hdc, x, 100, str, wcslen( str ) );
				TextOut( hdc, x2, 100, ssa.lpwcVersion, wcslen( ssa.lpwcVersion ) );

				wcscpy( str, L"Encoding:" );
				TextOut( hdc, x, 120, str, wcslen( str ) );
				TextOut( hdc, x2, 120, ssa.lpwcCharset, wcslen( ssa.lpwcCharset ) );

				wcscpy( str, L"# of Dialogues:" );
				TextOut( hdc, x, 140, str, wcslen( str ) );
				wsprintf( str, L"%lu", ssa.dwDialogues );
				TextOut( hdc, x2, 140, str, wcslen( str ) );

				wcscpy( str, L"Sample data:" );
				TextOut( hdc, x, 160, str, wcslen( str ) );
				SelectObject( hdc, hFontArial );
				TextOut( hdc, x2, 160, ssa.lpwcSampleDialogue, wcslen( ssa.lpwcSampleDialogue ) );
			}
			else
			{
				SetTextColor( hdc, RGB( 0x66, 0x66, 0x33 ) );
				wcscpy( str, L"Hit [O] to Open the SSA/ASS file." );
				TextOut( hdc, 180, 240, str, wcslen( str ) );
				wcscpy( str, L"Drag and Drop is also possible." );
				TextOut( hdc, 180, 260, str, wcslen( str ) );
			}
			SelectObject( hdc, hOldFont );
			EndPaint(hWnd, &ps);
			break;
		}
*/		
		case WM_DESTROY:
		{
			PostQuitMessage( 0 );
			break;
		}
		default:
		{
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
		}
   }

   return ( LRESULT ) FALSE;
}


LRESULT CALLBACK DlgProc(HWND hDlg, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	static HBRUSH hBrush = NULL;
	static SSAINFO ssa;
	switch ( uMessage )
	{
		case WM_CTLCOLORBTN:
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSTATIC:
		{
			COLORREF myColor = RGB( 0xff, 0xff, 0xee );
			if( ! hBrush )
			{
				hBrush = CreateSolidBrush( myColor );
			}
			SetBkColor( (HDC) wParam, myColor );
			if(
				( HANDLE ) lParam == GetDlgItem( hDlg, IDC_STATIC_FILENAME )
				||
				( HANDLE ) lParam == GetDlgItem( hDlg, IDC_STATIC_SAMPLE )
			)
			{
				SetTextColor( (HDC) wParam, RGB( 0, 0, 0xff ) );
			}
			return ( LRESULT ) hBrush;
		}
		case WM_INITDIALOG:
		{
			ZeroMemory( &ssa, sizeof( SSAINFO ) );
			HICON hIcon = LoadIcon( hInst, MAKEINTRESOURCE( IDI_ICON2 ) );
			SendMessage( hDlg, WM_SETICON, ICON_BIG, (LPARAM) hIcon );
			if( hFontArial )
			{
				SendDlgItemMessage( hDlg, IDC_EDIT_FILENAME, WM_SETFONT, ( WPARAM ) hFontArial, 0 );
				SendDlgItemMessage( hDlg, IDC_STATIC_FILENAME, WM_SETFONT, ( WPARAM ) hFontArial, 0 );
				SendDlgItemMessage( hDlg, IDC_STATIC_SAMPLE, WM_SETFONT, ( WPARAM ) hFontArial, 0 );
			}
			SetWindowText( hDlg, APP_NAME );
			SendDlgItemMessage( hDlg, IDC_COMBO_SIGN, CB_ADDSTRING, 0, (LPARAM) L"later" );
			SendDlgItemMessage( hDlg, IDC_COMBO_SIGN, CB_ADDSTRING, 0, (LPARAM) L"earlier" );
			SendDlgItemMessage( hDlg, IDC_COMBO_SIGN, CB_SETCURSEL, 0, 0 );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_ADDSTRING, 0, (LPARAM) L"23.976" );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_ADDSTRING, 0, (LPARAM) L"24" );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_ADDSTRING, 0, (LPARAM) L"25" );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_ADDSTRING, 0, (LPARAM) L"29.97" );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_ADDSTRING, 0, (LPARAM) L"30" );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_SETCURSEL, 0, 0 );
			SendDlgItemMessage( hDlg, IDC_COMBO_FPS, CB_LIMITTEXT, 10, 0 );
			SendDlgItemMessage( hDlg, IDC_COMBO_COND, CB_ADDSTRING, 0, (LPARAM) L">=" );
			SendDlgItemMessage( hDlg, IDC_COMBO_COND, CB_ADDSTRING, 0, (LPARAM) L"<=" );
			SendDlgItemMessage( hDlg, IDC_COMBO_COND, CB_SETCURSEL, 0, 0 );
			SendDlgItemMessage( hDlg, IDC_EDIT_SHIFT, EM_LIMITTEXT, 8, 0 );
			SendDlgItemMessage( hDlg, IDC_EDIT_FRAME, EM_LIMITTEXT, 8, 0 );
			SetDlgItemInt( hDlg, IDC_EDIT_FRAME, 0, FALSE );
			CheckDlgButton( hDlg, IDC_CHECK_SUB10, 1 );
			EnableWindow( GetDlgItem( hDlg, IDC_CHECK_SUB10 ), FALSE );
			ShowSSAInfo( hDlg, &ssa );
			return TRUE;
		}
		case WM_COMMAND:
			switch( LOWORD( wParam ) )
			{
				case IDM_EXIT:
				case IDCANCEL: // Enabling IDCANCEL will enable [Esc]
					DestroyWindow( hDlg );
					break;
				case IDM_OPEN:
					GetInputFileName( hDlg, &ssa );
					ShowSSAInfo( hDlg, &ssa );
					break;
				case IDM_SHIFT:
					DoShift( hDlg, &ssa );
					break;
				case IDM_ABOUT:
				{
					DialogBox( hInst, (LPCTSTR)IDD_ABOUTBOX, hDlg, (DLGPROC)About );
					break;
				}
				default:
					break;
			}
			break;
		case WM_DROPFILES:
		{
			WCHAR lpwcPath[ MAX_PATH + 2 ];
			DragQueryFile( ( HDROP ) wParam, 0U, lpwcPath, MAX_PATH + 1 );
			GetSSAInfo( lpwcPath, &ssa );
			ShowSSAInfo( hDlg, &ssa );
			break;
		}
		case WM_DESTROY:
		{
			if( hBrush )
			{
				DeleteObject( hBrush );
				hBrush = NULL;
			}
			hDlgModeless = NULL;
			SendMessage( g_hWnd, WM_DESTROY, 0, 0 );
			break;
		}
		default:
			return FALSE;
	}
    return TRUE;
}

BOOL ShowSSAInfo( HWND hDlg, const LPSSAINFO s )
{
	if( s->dwDialogues == 0 )
	{
		SetDlgItemText( hDlg, IDC_STATIC_FILENAME,	L"Hit [O] to Open SSA/ASS. Drag & Drop is also possible." );
		SetDlgItemText( hDlg, IDC_STATIC_NUMBER, L"" );
	}
	else
	{
		WCHAR str[ MAX_PATH ];
		wcscpy( str, s->lpwcFileName );
		if( wcslen( str ) >= 30 ) str[ 30 ] = L'\0';
		wcscat( str, L"..." );
		SetDlgItemText( hDlg, IDC_STATIC_FILENAME, str );
		SetDlgItemInt(  hDlg, IDC_STATIC_NUMBER, s->dwDialogues, FALSE );
	}
	SetDlgItemText( hDlg, IDC_EDIT_FILENAME, s->lpwcFilePath );
	SetDlgItemText( hDlg, IDC_STATIC_VERSION, s->lpwcVersion );
	SetDlgItemText( hDlg, IDC_STATIC_ENCODING, s->lpwcCharset );
	SetDlgItemText( hDlg, IDC_STATIC_SAMPLE, s->lpwcSampleDialogue );
	return TRUE;
}

BOOL DoShift( HWND hDlg, LPSSAINFO s )
{
	if( wcslen( s->lpwcFilePath ) == 0 )
	{
		MessageBox( hDlg, L"Specify the filename.", APP_NAME, MB_ICONEXCLAMATION | MB_OK );
		return FALSE;
	}


	int iSign = ( SendDlgItemMessage( hDlg, IDC_COMBO_SIGN, CB_GETCURSEL, 0, 0 ) == 1 ) ? ( -1 ) : ( +1 ) ;
	UINT uShift = GetDlgItemInt( hDlg, IDC_EDIT_SHIFT, NULL, FALSE );
	WCHAR str[ 100 ];

	SendMessage( GetDlgItem( hDlg, IDC_COMBO_FPS ), WM_GETTEXT, 20, ( LPARAM ) str );
	if( wcslen( str ) > 20 )
	{
		MessageBox( hDlg, str, L"Abnormal fps.", MB_ICONEXCLAMATION | MB_OK );
		return FALSE;
	}
	char tmpstr[ 1024 ];
	double dFps;
	if( WideCharToMultiByte( CP_UTF8, 0, str, -1, tmpstr, 128, NULL, NULL ) )
	{
		dFps = atof( tmpstr );
	}
	else
	{
		MessageBox( hDlg, str, L"!WideCharToMultiByte", MB_ICONEXCLAMATION | MB_OK );
		return FALSE;
	}

	LONG lFrame = GetDlgItemInt( hDlg, IDC_EDIT_FRAME, NULL, FALSE );
	BOOL bStart = ( SendDlgItemMessage( hDlg, IDC_COMBO_COND, CB_GETCURSEL, 0, 0 ) != 1 );
	
	ShiftSSA( hDlg, s->lpwcFilePath, ( iSign ) * uShift, dFps, lFrame, bStart );

	return TRUE;
}